/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2014-2017 by Center for Embedded Computing Systems
 *                             Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2016-2017 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2016-2017 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2016-2017 by SCSK Corporation, JAPAN
 *  Copyright (C) 2016-2017 by SUZUKI MOTOR CORPORATION 
 *  Copyright (C) 2016-2017 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2016-2017 by Witz Corporation
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: ModelCarControl.h 814 2017-03-10 07:11:37Z fsi-masayam $
 */

/*
 *		ǥ롼ץإåե
 */

#ifndef TOPPERS_MODEL_CAR_CONTROL_H
#define TOPPERS_MODEL_CAR_CONTROL_H

#include "SystemServices.h"

/*
 *  ѥȥϢ : ˥塼ȥΥƥ󥰳٤ν
 */
#define STEER_NEUTRAL_INIT	0

/*
 * ®ƥ󥰺/Ǿ
 */
#define DRIVE_SPEED_MAX		64
#define DRIVE_SPEED_MIN		-63
#define STEER_ANGLE_MAX		64
#define STEER_ANGLE_MIN		-63

/*
 *  ƥ󥰥˥塼ȥĴͤκ/Ǿ
 */
#define STEER_NEUTRAL_MIN	-32
#define STEER_NEUTRAL_MAX	32

/*
 *  Ĵ
 */
#define SPEED_GAIN_INIT		6
#define SPEED_GAIN_MID		10
#define SPEED_GAIN_MIN		3
#define SPEED_GAIN_MAX		17

/*
 *  DriveManagerεư
 */
#define DRIVEMANAGER_TASK_CYCLE_MS		10

/*
 *   : ưΥܥǥϤ³ƥ
 *           ǲǼ  
 */
#define INIT_BODY_BLINK_COUNT		3 
#define INIT_BODY_BLINK_CYCLE_MS	500

/*
 *   : CAN
 */
#define BODYCMD_CANMSG_SEND_CYCLE_MS	100

/*
 *  ֥
 */
#define BUZZER_OFF			0U
#define BUZZER_ON			1U
#define BUZZER_INTERVAL_ON	2U

/*
 *  󥫡
 */
#define WINKER_OFF		0U
#define WINKER_L_ON		1U
#define WINKER_R_ON		2U
#define WINKER_LR_ON	3U
#define WINKER_L_BLINK	4U
#define WINKER_R_BLINK	5U
#define WINKER_LR_BLINK	6U

/*
 *  Ϥؤλؼ¤
 */
typedef struct {
	sint8	angle;
	sint8	speed;
	sint8	steern;
	sint8	gain;
	boolean brake;
	boolean headlamp;
	boolean foglamp;
	boolean winker_l;
	boolean winker_r;
	boolean hazard;	
}CONTCMD;

/*
 *  ϤؤΥƥ󥰥˥塼ȥϢλؼ
 */
#define CONTCMD_STEERN_I	1U
#define CONTCMD_STEERN_R	2U
#define CONTCMD_STEERN_L	3U

/*
 *  ϤؤΥ⡼Ϣλؼ
 */
#define CONTCMD_GAIN_I	1U
#define CONTCMD_GAIN_U	2U
#define CONTCMD_GAIN_D	3U

/*
 *  Ϥؤλؼѿ
 */
extern volatile CONTCMD g_contcmd;

/*
 * ƥAPI
 */
extern void SetSteerAngle(sint8 angle);

/*
 *  ®API
 */
extern void SetDriveSpeed(sint8 speed);

/*
 *  ֥졼API
 */
extern void SetBrake(boolean brake);

/*
 *  BlinLedѤν(blinkled.c)
 */
extern void LedBlinkerInit(void);

/*
 *  ܡɾLED
 */
extern void LedBlinkerHook(void);

/*
 *  ѥȥ쥤Ϥν(RcCar.c)
 */
extern void RcCarInit(void);

/*
 *  ѥȥ쥤Ϥ
 */
extern void RcCarPeriodicHook(void);

/*
 *  Ϥν(OperationManager.c)
 */
extern void OperationInit(void);

/*
 *  Ϥ(OperationManager.c)
 */
extern void OperationPeriodicHook(void);

/*
 *  Ϥ(DriveManager.c)
 */
extern void DriveManagerPeriodicHook(void);

#endif /* TOPPERS_MODEL_CAR_CONTROL_H */

