/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2014-2017 by Center for Embedded Computing Systems
 *                             Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2017 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2016-2017 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2016-2017 by SCSK Corporation, JAPAN
 *  Copyright (C) 2016-2017 by SUZUKI MOTOR CORPORATION 
 *  Copyright (C) 2016-2017 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2016-2017 by Witz Corporation
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: DriveManager.c 814 2017-03-10 07:11:37Z fsi-masayam $
 */

/*
 *		ϴϢ
 */

#include "t_syslog.h"
#include "Com.h"
#include "ModelCarControl.h"

/*
 *  ƥ󥰤Υ˥塼ȥ
 */
sint8	steer_neutral = STEER_NEUTRAL_INIT;

/*
 *  ®Υ
 */
sint8	speed_gain = SPEED_GAIN_INIT;

/*
 *  ƥ󥰥˥塼ȥ®ĴACKλ
 */
#define ACK_CNT_MAX		8U

/*
 *  ƥ󥰥˥塼ȥ®ĴACKѿ
 */
static uint8	acklr_cnt = 0U;
static uint8	ackr_cnt = 0U;
static uint8	ackl_cnt = 0U;

/*
 *  ɳѤȼ®η
 */
void
DrivingControl(void)
{
	/* ƥ󥰥˥塼ȥĴ */
	switch (g_contcmd.steern) {
	  case CONTCMD_STEERN_I:
		steer_neutral = STEER_NEUTRAL_INIT;
		acklr_cnt = ACK_CNT_MAX;
		break;
	  case CONTCMD_STEERN_R:
		/* (-)Ĵ */
		if (steer_neutral > STEER_NEUTRAL_MIN) {
			steer_neutral--;
		}
		ackr_cnt = ACK_CNT_MAX;
		break;
	  case CONTCMD_STEERN_L:
		/* (+)Ĵ */
		if (steer_neutral < STEER_NEUTRAL_MAX) {
			steer_neutral++;
		}
		ackl_cnt = ACK_CNT_MAX;
		break;
	  default:
		/* ׵ʤ */
		break;
	}

	/* Ĵ */
	switch (g_contcmd.gain) {
	  case CONTCMD_GAIN_I:
		speed_gain = SPEED_GAIN_INIT;
		acklr_cnt = ACK_CNT_MAX;
		break;
	  case CONTCMD_GAIN_U:
		/* 夲 */
		if (speed_gain < SPEED_GAIN_MAX) {
			speed_gain++;
		}
		ackr_cnt = ACK_CNT_MAX;
		break;
	  case CONTCMD_GAIN_D:
		/* 򲼤 */
		if (speed_gain > SPEED_GAIN_MIN) {
			speed_gain--;
		}
		ackl_cnt = ACK_CNT_MAX;
		break;
	  default:
		/* ׵ʤ */
		break;
	}

	/* ɳѷ */
	SetSteerAngle(g_contcmd.angle + steer_neutral);

	/* ® */
	SetDriveSpeed((g_contcmd.speed * speed_gain) / SPEED_GAIN_MID);

	/* ֥졼 */
	SetBrake(g_contcmd.brake);
}

/*
 *  ưΥܥǥϤγǧǽλޤǤΥ
 */
#define START_CNT_MAX	(INIT_BODY_BLINK_CYCLE_MS*INIT_BODY_BLINK_COUNT*2)/DRIVEMANAGER_TASK_CYCLE_MS

void
BodyControl(void)
{
	static uint16	start_cnt = 0U;
	boolean			tmp_headlamp = FALSE;
	boolean			tmp_foglamp = FALSE;
	boolean			tmp_brakelamp = FALSE;
	boolean			tmp_backlamp = FALSE;
	uint8			tmp_winker = 0U;
	uint8			tmp_buzzer = 0U;
	static boolean	toggle_headlamp = FALSE;
	static boolean	toggle_foglamp = FALSE;
	static boolean	toggle_hazard = FALSE;
	static boolean	toggle_winker_r = FALSE;
	static boolean	toggle_winker_l = FALSE;
	static boolean	pre_headlamp = FALSE;
	static boolean	pre_foglamp = FALSE;
	static boolean	pre_hazard = FALSE;
	static boolean	pre_winker_r = FALSE;
	static boolean	pre_winker_l = FALSE;

	/* ư */
	if (start_cnt <= START_CNT_MAX) {
		/* WinkerLight(headfogbrakeback) */
		if ((((start_cnt / (START_CNT_MAX/(INIT_BODY_BLINK_COUNT*2))) % 2U) == 0U)
			&& (start_cnt != START_CNT_MAX)) {
			tmp_headlamp  = TRUE;
			tmp_foglamp   = TRUE;
			tmp_brakelamp = TRUE;
			tmp_backlamp  = TRUE;
			tmp_winker    = WINKER_LR_ON;
			tmp_buzzer    = BUZZER_ON;
		}
		else {
			tmp_headlamp  = FALSE;
			tmp_foglamp   = FALSE;
			tmp_brakelamp = FALSE;
			tmp_backlamp  = FALSE;
			tmp_winker    = WINKER_OFF;
			tmp_buzzer    = BUZZER_OFF;
		}
		/* ưȥ󥯥 */
		start_cnt++;
	}
	/* ̾ﵯư */
	else {
		/* FALSETRUEܻ˳ƥȥڤؤ */
		if ((pre_headlamp == FALSE) && (g_contcmd.headlamp == TRUE)) {
			toggle_headlamp = (toggle_headlamp == FALSE) ? TRUE : FALSE;
		}
		if ((pre_foglamp == FALSE) && (g_contcmd.foglamp == TRUE)) {
			toggle_foglamp = (toggle_foglamp == FALSE) ? TRUE : FALSE;
		}
		if ((pre_hazard == FALSE) && (g_contcmd.hazard == TRUE)) {
			toggle_hazard = (toggle_hazard == FALSE) ? TRUE : FALSE;
		}
		if ((pre_winker_r == FALSE) && (g_contcmd.winker_r == TRUE)) {
			toggle_winker_r = (toggle_winker_r == FALSE) ? TRUE : FALSE;
		}
		if ((pre_winker_l == FALSE) && (g_contcmd.winker_l == TRUE)) {
			toggle_winker_l = (toggle_winker_l == FALSE) ? TRUE : FALSE;
		}

		/*
		 *  ׾Ƚ
		 */
		/* إåɥ׾Ƚ */
		if (toggle_headlamp == TRUE) {
			tmp_headlamp = TRUE;
		}
		else {
			tmp_headlamp = FALSE;
		}
		
		/* ե׾Ƚ */
		if (toggle_foglamp == TRUE) {
			tmp_foglamp = TRUE;
		}
		else {
			tmp_foglamp = FALSE;
		}
		
		/* ֥졼׾Ƚ */
		if (g_contcmd.brake == TRUE) {
			tmp_brakelamp = TRUE;
		}
		else {
			tmp_brakelamp = FALSE;
		}
		
		/* Хå׾Ƚ */
		if (g_contcmd.speed < 0) {
			tmp_backlamp = TRUE;
		}
		else {
			tmp_backlamp = FALSE;
		}

		/*
		 *  󥫡Ƚ
		 */
		/* 󡤥˥塼ȥĴؼ */
		if ((acklr_cnt != 0U) || (ackr_cnt != 0U) || (ackl_cnt != 0U)) {
			if (acklr_cnt != 0U) {
				acklr_cnt--;
				tmp_winker = (acklr_cnt == 0)? WINKER_OFF : WINKER_LR_ON;
			}
			if (ackr_cnt != 0U) {
				ackr_cnt--;
				tmp_winker = (ackr_cnt == 0)? WINKER_OFF : WINKER_R_ON;
			}
			if (ackl_cnt != 0U) {
				ackl_cnt--;
				tmp_winker = (ackl_cnt == 0)? WINKER_OFF : WINKER_L_ON;
			}
		}
		else {
			/*  */
			if ((toggle_hazard == TRUE) ||
				((toggle_winker_r == TRUE) && (toggle_winker_l == TRUE))) {
				tmp_winker = WINKER_LR_BLINK;
			}
			/* Τ */
			else if (toggle_winker_r == TRUE) {
				tmp_winker = WINKER_R_BLINK;
			}
			/* Τ */
			else if (toggle_winker_l == TRUE) {
				tmp_winker = WINKER_L_BLINK;
			}
			/*  */
			else {
				tmp_winker = WINKER_OFF;
			}
		}

		/*
		 * ֥Ƚ
		 */
		if (g_contcmd.speed < 0) {
			tmp_buzzer = BUZZER_INTERVAL_ON;
		}
		else {
			tmp_buzzer = BUZZER_OFF;
		}

		/* ¸ */
		pre_headlamp = g_contcmd.headlamp;
		pre_foglamp  = g_contcmd.foglamp;
		pre_hazard   = g_contcmd.hazard;
		pre_winker_r = g_contcmd.winker_r;
		pre_winker_l = g_contcmd.winker_l;
	}

	/*  ܥǥECUCAN */
	Com_SendSignal(ComConf_ComSignal_ComSignal0, &tmp_winker);
	Com_SendSignal(ComConf_ComSignal_ComSignal1, &tmp_buzzer);
	Com_SendSignal(ComConf_ComSignal_ComSignal2, &tmp_backlamp);
	Com_SendSignal(ComConf_ComSignal_ComSignal3, &tmp_brakelamp);
	Com_SendSignal(ComConf_ComSignal_ComSignal4, &tmp_headlamp);
	Com_SendSignal(ComConf_ComSignal_ComSignal5, &tmp_foglamp);

	return;
}

/*
 *  Ϥ
 */
void
DriveManagerPeriodicHook(void)
{
	static	boolean executed = FALSE;

	/*  ưΤ߼¹ */
	if (executed == FALSE) {
		syslog(LOG_INFO, "DriveManagerPeriodicHook : Start!");
		executed = TRUE;
	}

	/* ưϤ */
	DrivingControl();

	/* ܥǥϤ */
	BodyControl();

	return;
}

