/*
 *  Copyright (C) 2016-2017 by Center for Embedded Computing Systems
 *                             Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2016-2017 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2016-2017 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2016-2017 by SCSK Corporation, JAPAN
 *  Copyright (C) 2016-2017 by SUZUKI MOTOR CORPORATION 
 *  Copyright (C) 2016-2017 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2016-2017 by Witz Corporation
 *
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 *
 *  {\tgEFÁCAUTOSARiAUTomotive Open System ARchitecturejd
 *  lɊÂĂDL̋́CAUTOSAR̒mIŶ
 *  ͂ȂDAUTOSAŔCAUTOSARdlɊÂ\tgEFApړIŗ
 *  p҂ɑ΂āCAUTOSARp[gi[ɂȂ邱Ƃ߂ĂD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 *
 *  $Id: SystemServices.c 814 2017-03-10 07:11:37Z fsi-masayam $
 */

/*
 *		SystemServicesvO
 */
#include "t_syslog.h"
#include "sysmod/serial.h"
#include "sysmod/banner.h"
#include "SystemServices.h"

/*
 *  [UC֐
 *
 *  AvP[V[h̔fƃJ[lN
 */
sint32
main(void)
{
	AppModeType	crt_app_mode = MainApp;

	/*
	 *  OSN
	 */
	StartOS(crt_app_mode);

	while (1) {
	}
}

/*
 *  X^[gAbvtbN[`
 */
void
StartupHook(void)
{
	/*
	 *  ʂ̏
	 */ 
	syslog_initialize();
	syslog_msk_log(LOG_UPTO(LOG_INFO));
	InitSerial();
	print_banner();
	syslog(LOG_INFO, "Model Car Control System Start");

	/* tbŇĂяo */
	InitHook();

	return;
}

/*
 *  G[tbN[`
 */
void
ErrorHook(StatusType Error)
{
	TaskType	tskid;
	StatusType	ercd;

	/* dNvG[͖ */
	if ((OSErrorGetServiceId() == OSServiceId_ActivateTask) && (Error == E_OS_LIMIT)) {
		return;
	}

	syslog(LOG_NOTICE, "## ErrorHook is called !! (%d)", Error);

	ercd = GetTaskID(&tskid);
	if (ercd == E_OK) {
		syslog(LOG_NOTICE, "GetTaskID: %d", (sintptr) tskid);
	}
	else {
		syslog(LOG_NOTICE, "GetTaskID is unavailable.");
	}
	syslog(LOG_NOTICE, "GetISRID: %d", (sintptr) GetISRID());
	syslog(LOG_NOTICE, "OSErrorGetServiceId(): %d", OSErrorGetServiceId());

	ShutdownOS(E_OK);

	return;
}

/*
 *  veNVtbN[`
 */
ProtectionReturnType
ProtectionHook(StatusType FatalError)
{
	StatusType ercd;

	syslog(LOG_INFO, "");
	syslog(LOG_INFO, "ProtectionHook");

	if (FatalError == E_OS_STACKFAULT) {
		syslog(LOG_INFO, "E_OS_STACKFAULT");
		ercd = PRO_SHUTDOWN;
	}
	else if (FatalError == E_OS_PROTECTION_EXCEPTION) {
		syslog(LOG_INFO, "E_OS_PROTECTION_EXCEPTION");
		ercd = PRO_IGNORE;
	}
	else {
		ercd = PRO_SHUTDOWN;
	}

	return(ercd);
}

/*
 *  ^XNi10msNj
 */
TASK(HighTask)
{
	HighTaskHook();
	TerminateTask();

	return;
}

/*
 *  ^XNi100msNj
 */
TASK(LowTask)
{
	LowTaskHook();
	TerminateTask();

	return;
}

/*
 *  荞ݏi125sԊuł̊荞݁BOSA[R[obNőpBj
 */
ALARMCALLBACK(TimerInterruptCycAlarmCb)
{
	TimerInterrupt();

	return;
}

